#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

void answer(int n, int m, int maskx, int masky) {
    cout << "YES" << '\n';
    vector<pair<int, int>> a, b;
    int k = 0;
    for (int i = 0; i < n; i++) {
        if (((maskx >> i) & 1))
            a.emplace_back(1, i + 1), k++;
    }
    k = 0;
    for (int j = 0; j < m; j++) {
        if (((masky >> j) & 1))
            b.emplace_back(2, j + 1), k++;
    }
    cout << sz(a) + sz(b) << '\n';
    for (auto e : a)
        cout << e.first << ' ' << e.second << '\n';
    for (auto e : b)
        cout << e.first << ' ' << e.second << '\n';
    exit(0);
}

void runtimeerror() {
    int n, m, sum = 0, S;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> arr[i][j], sum += arr[i][j];
    cin >> S;

    vector<int> sumx(1LL << n);
    for (int mask = 0; mask < (1LL << n); mask++)
        for (int i = 0; i < n; i++)
            if ((mask >> i) & 1)
                for (int j = 0; j < m; j++)
                    sumx[mask] += arr[i][j];

    int timer = 1;
    for (int mask = 0; mask < (1LL << n); mask++, timer++) {
        vector<int> x;
        for (int i = 0; i < n; i++)
            if ((mask >> i) & 1)
                x.emplace_back(i);

        int mask1 = 0, f = (sum - S) - sumx[mask];
        if (f < 0) continue;
        if (f == 0) {
            answer(n, m, mask, 0);
        }

        vector<vector<bool>> dp(m + 1, vector<bool> (f + 1));
        vector<vector<pair<int, int>>> par(m + 1, vector<pair<int, int>> (f + 1));
        dp[0][0] = true;

        for (int j = 1; j <= m; j++) {
            int s = 0;
            for (int i = 0; i < n; i++)
                s += arr[i][j - 1];
            for (auto i : x)
                s -= arr[i][j - 1];

            for (int w = s; w < sz(dp[j]); w++) {
                if (!dp[j][w]) {
                    dp[j][w] = dp[j - 1][w];
                    par[j][w] = {w, par[j - 1][w].second};
                }

                if (w - s >= 0 && dp[j - 1][w - s]) {
                    dp[j][w] = true;
                    par[j][w] = {w - s, j - 1};
                }
            }
        }


        for (int j = 1; j <= m; j++) {
            if (!dp[j][f]) continue;
            int v = f, a = j;
            mask1 |= (1LL << (j - 1));
            while (v > 0) {
                mask1 |= (par[a][v].second > 0 ? (1LL << (par[a][v].second - 1)) : 0);
                int buf = a;
                a = par[a][v].second;
                v = par[buf][v].first;
            }
            answer(n, m, mask, mask1);
        }

    }
    cout << "NO";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}