#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

int lg(int x) {
    for (int i = 0; i < 16; i++)
        if ((x >> i) & 1)
            return i;
}

int rg(int x) {
    for (int i = 15; i >= 0; i--) {
        if ((x >> i) & 1)
            return i;
    }
}

void answer(int n, int m, int maskx, int masky) {
    cout << "YES" << '\n';
    vector<pair<int, int>> a, b;
    int k = 0;
    for (int i = 0; i < n; i++) {
        if (((maskx >> i) & 1))
            a.emplace_back(1, i + 1), k++;
    }
    k = 0;
    for (int j = 0; j < m; j++) {
        if (((masky >> j) & 1))
            b.emplace_back(2, j + 1), k++;
    }
    cout << sz(a) + sz(b) << '\n';
    for (auto e : a)
        cout << e.first << ' ' << e.second << '\n';
    for (auto e : b)
        cout << e.first << ' ' << e.second << '\n';
    exit(0);
}

void runtimeerror() {
    int n, m, sum = 0, S, mx = 0;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> arr[i][j], sum += arr[i][j], mx = max(mx, arr[i][j]);
    cin >> S;

    if (S > sum) {
        cout << "NO";
        return;
    }

    if (mx <= 6) {
        vector<int> sumx(1LL << n);
        for (int mask = 0; mask < (1LL << n); mask++)
            for (int i = 0; i < n; i++)
                if ((mask >> i) & 1)
                    for (int j = 0; j < m; j++)
                        sumx[mask] += arr[i][j];

        for (int mask = 0; mask < (1LL << n); mask++) {
            vector<int> x;
            for (int i = 0; i < n; i++)
                if ((mask >> i) & 1)
                    x.emplace_back(i);

            int mask1 = 0, f = (sum - S) - sumx[mask];
            if (f < 0) continue;

            vector<bool> dp(f + 1);
            dp[0] = true;
            vector<pair<int, int>> par(f + 1, {0, 0});

            for (int j = 0; j < m; j++) {
                int s = 0;
                for (int i = 0; i < n; i++)
                    s += arr[i][j];
                for (auto i: x)
                    s -= arr[i][j];

                if (s == 0) continue;

                for (int w = f; w >= s; w--) {
                    if (dp[w - s]) {
                        dp[w] = true;
                        par[w] = {w - s, j};
                    }
                }
            }

            if (!dp[f]) continue;
            int v = f;
            while (v > 0) {
                mask1 |= (1LL << par[v].second);
                v = par[v].first;
            }
            answer(n, m, mask, mask1);

        }
        cout << "NO";
    } else {
        vector<int> sumx(1LL << n), sumy(1LL << m), l, r;
        map<int, pair<int, int>> cnt;
        for (int mask = 0; mask < (1LL << n); mask++)
            for (int i = 0; i < n; i++)
                if ((mask >> i) & 1)
                    for (int j = 0; j < m; j++)
                        sumx[mask] += arr[i][j];

        for (int mask = 0; mask < (1LL << m); mask++) {
            for (int j = 0; j < m; j++)
                if ((mask >> j) & 1)
                    for (int i = 0; i < n; i++)
                        sumy[mask] += arr[i][j];
            if (mask == 0) {
                l.emplace_back(0);
                r.emplace_back(0);
                continue;
            }
            if (rg(mask) <= (m + 1) / 2)
                l.emplace_back(mask);
            else if(lg(mask) > (m + 1) / 2)
                r.emplace_back(mask);
        }

        int timer = 1;
        for (int mask = 0; mask < (1LL << n); mask++, timer++) {
            vector<int> x;
            for (int i = 0; i < n; i++)
                if ((mask >> i) & 1)
                    x.emplace_back(i);

            for (auto mask1 : l) {
                int s = sumy[mask1];
                for (int j = 0; j <= (m + 1) / 2; j++)
                    if ((mask1 >> j) & 1) {
                        for (auto i : x)
                            s -= arr[i][j];
                    }
                cnt[s] = {timer, mask1};
            }

            for (auto mask1 : r) {
                int s = sumy[mask1];
                for (int j = (m + 1) / 2 + 1; j < m; j++)
                    if ((mask1 >> j) & 1) {
                        for (auto i : x)
                            s -= arr[i][j];
                    }


                if ((sum - S) - sumx[mask] - s >= 0 && cnt.find((sum - S) - sumx[mask] - s) != cnt.end() && cnt[(sum - S) - sumx[mask] - s].first == timer)
                    answer(n, m, mask, (mask1 | cnt[(sum - S) - sumx[mask] - s].second));
            }
        }
        cout << "NO";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}