#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

const long long nmax = 2e5 + 100;

vector<vector<int>> g(nmax);
vector<int> d(nmax);

void dfs(int v, int p) {
    d[v] = (p == -1 ? 0 : d[p] + 1);
    for (auto to : g[v])
        if (to != p)
            dfs(to, v);
}

void checker(int v, int p, int &cnt, int len, int k) {
    if (d[v] - k > len) {
        cnt++;
        k = d[v] - 1;
    }
    for (auto to : g[v])
        if (to != p)
            checker(to, v, cnt, len, k);
}

void runtimeerror() {
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }

    for (int i = 1; i <= (t == 0 ? 1 : n); i++) {
        dfs(i, -1);
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2, cnt = 0;
            checker(i, -1, cnt, mid, 0);
            if (cnt <= k) r = mid;
            else l = mid;
        }
        cout << r << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}