#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

const long long nmax = 2e5 + 100;
const long long inf = 9099999999999999999;

vector<vector<int>> g(nmax), dp(nmax);
int n;

void bfs(int s) {
    vector<int> par(n + 1, -1);
    queue<int> q;
    q.push(s);
    par[s] = s;
    dp[s][0] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (v != s) {
            for (int k = 1; k <= n; k++) {
                dp[v][k] = min(dp[v][k], dp[par[v]][k - 1]);
                dp[v][k] = min(dp[v][k], dp[par[v]][k] + 1);
            }
        }
        for (auto to : g[v])
            if (par[to] == -1) {
                par[to] = v;
                q.push(to);
            }

    }

//    if (p == -1) dp[v][0] = 0;
//    for (auto to : g[v]) {
//        if (to == p) continue;
//
//        dfs(to, v);
//
//        if (p == -1) continue;

//    }
}

void runtimeerror() {
    int k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }

    for (int i = 1; i <= (t == 0 ? 1 : n); i++) {
        for (int j = 0; j <= n; j++)
            dp[j].clear(), dp[j].assign(n + 1, inf);
        bfs(i);

        for (int j = 1; j <= n; j++) {
            int res = 0;
            for (int u = 1; u <= n; u++)
                if (sz(g[u]) == 1 && u != i)
                    res += dp[u][j];
            if (res <= k) {
                cout << j << ' ';
                break;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}