#include <bits/stdc++.h>

using namespace std;

#define int long long

const long long nmax = 1e6 + 1;

vector<int> primes, ans(nmax);
vector<bool> prime(nmax, true), used(nmax);
vector<vector<int>> g(nmax);

void dfs(int v, int c) {
    ans[v] = c;
    for (auto to : g[v])
        if (ans[to] == 0)
            dfs(to, (c == 1 ? 2 : 1));
}

void runtimeerror() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; i++)
        cin >> arr[i], used[arr[i]] = true;


    prime[0] = prime[1] = false;
    for (int i = 2; i < nmax; i++) {
        if (prime[i]) {
            primes.emplace_back(i);
            for (int j = i * i; j < nmax; j += i) {
                prime[j] = false;
            }
        }
    }

    for (int i = 1; i < nmax; i++) {
        if (!used[i]) continue;
        for (auto e : primes) {
            if (e * i >= nmax) break;
            if (used[e * i]) {
                g[i].emplace_back(e * i);
                g[e * i].emplace_back(i);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (ans[arr[i]] > 0) continue;
        dfs(arr[i], 1);
    }

    for (int i = 0; i < n; i++)
        cout << ans[arr[i]] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    runtimeerror();
    return 0;
}
