#include <bits/stdc++.h>

using namespace std;

const long long nmax = 1e6 + 1;
const long long inf = 9099999999999999999;

long long f(long long n, long long timer, vector<long long> &a, vector<long long> &t) {
    long long res = 0;
    for (long long i = 0; i < n; i++) {
        if (timer >= a[i] + t[i]) {
            if (timer - a[i] - t[i] + 1LL >= 32LL)
                return inf;
            res += (1LL << (timer - a[i] - t[i] + 1LL));
        } else if (timer >= a[i]) {
            res++;
        }
    }
    return res;
}

void runtimeerror() {
    long long n, m;
    cin >> n >> m;
    vector<long long> a(n), t(n);
    for (long long i = 0; i < n; i++)
        cin >> a[i];
    for (long long i = 0; i < n; i++)
        cin >> t[i];

    long long l = 0, r = 1e18 + 1;
    while (r - l > 1) {
        long long mid = (r + l) / 2;
        if (f(n, mid, a, t) <= m) l = mid;
        else r = mid;
    }

    if (f(n, l, a, t) != m) cout << -1;
    else cout << l;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    runtimeerror();
    return 0;
}
