#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

struct ST {
    vector<vector<int>> dp;
    vector<int> lg;

    ST() {}

    ST(vector<int> &arr) {
        int n = sz(arr);
        dp.assign(22, vector<int> (n));
        lg.assign(n + 1, 0);

        for (int i = 2; i <= n; i++)
            lg[i] = lg[i / 2] + 1;
        for (int i = 0; i < n; i++)
            dp[0][i] = arr[i];
        for (int j = 1; j < 22; j++)
            for (int i = 0; i + (1LL << j) <= n; i++)
                dp[j][i] = min(dp[j - 1][i], dp[j - 1][i + (1LL << (j - 1))]);
    }

    int get(int l, int r) {
        int j = lg[r - l + 1];
        l--, r--;
        return min(dp[j][l], dp[j][r - (1LL << j) + 1]);
    }
};

void runtimeerror() {
    int n;
    cin >> n;
    vector<int> arr(n + 2);
    for (int i = 1; i <= n; i++)
        cin >> arr[i];

    vector<int> pref(n + 2), suf(n + 2);
    vector<int> l(n + 2), r(n + 2);
    l[0] = 1;
    r[n + 1] = n;

    pref[1] = 1;
    for (int i = 2; i <= n; i++) {
        if (arr[i] - arr[i - 1] > 0) pref[i]++;
        pref[i] += pref[i - 1];
    }

    suf[n] = 1;
    for (int i = n - 1; i >= 1; i--) {
        if (arr[i] - arr[i + 1] > 0) suf[i]++;
        suf[i] += suf[i + 1];
    }

    for (int i = n; i >= 1; i--) {
        if(arr[i] - arr[i + 1] <= 0)
            r[i] = i;
        else
            r[i] = r[i + 1];
    }
    for (int i = 1; i <= n; i++) {
        if(arr[i] - arr[i - 1] <= 0)
            l[i] = i;
        else
            l[i] = l[i - 1];
    }

//    for (auto e : l)
//        cout << e << ' ';
//    line;
//    for (auto e : r)
//        cout << e << ' ';
//    line;
//    for (auto e : pref)
//        cout << e << ' ';
//    line;
//    for (auto e : suf)
//        cout << e << ' ';
//    line;
//
//    line;

    int ans = 0;
    for (int i = 1; i <= n; i++) {
        int cnt1 = pref[i] - pref[l[i]] + 1;
        int cnt2 = suf[i] - suf[r[i]] + 1;
        ans += max(0LL, cnt1 * cnt2);
//        cout << i << ' ' << cnt1 << ' ' << cnt2 << '\n';
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}
