#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())
#define line cout<<"\n";

const long long nmax = 2e5 + 100;
const long long inf = 9099999999999999999;

vector<vector<int>> g(nmax);
vector<vector<vector<int>>> dp;
int n;

void bfs(int s) {
    vector<int> par(n + 1, -1);
    queue<int> q;
    q.push(s);
    par[s] = s;
    for (int i = 0; i <= n; i++)
        dp[s][i][0] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (v != s) {
            for (int i = 1; i <= n; i++) {
                for (int j = i; j >= 1; j--) {
                    dp[v][i][j] = min(dp[v][i][j], dp[par[v]][i][j - 1]);
                    dp[v][i][1] = min(dp[v][i][1], dp[par[v]][i][j] + 1);
                }
            }
        }
        for (auto to : g[v])
            if (par[to] == -1) {
                par[to] = v;
                q.push(to);
            }

    }
}

void runtimeerror() {
    int k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }

    dp.assign(n + 1, {});
    for (int i = 1; i <= (t == 0 ? 1 : n); i++) {
        for (int j = 0; j <= n; j++)
            dp[j].clear(), dp[j].assign(n + 1, vector<int> (n + 1, inf));
        bfs(i);

        for (int j = 1; j <= n; j++) {
            int res = 0;
            for (int u = 1; u <= n; u++)
                if (sz(g[u]) == 1 && u != i)
                    res += *min_element(all(dp[u][j]));
            if (res <= k) {
                cout << j << ' ';
                break;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    return 0;
}