#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define sz(a) (a.size())

const long long mod = 1e9 + 7;
const long long nmax = 2e5 + 100;
const long long inf = 9099999999999999999;

mt19937 rnd();

vector<int> arr(nmax, -1), num(nmax);
vector<vector<int>> g(nmax, vector<int> (2));
int tree[4 * nmax], p[4 * nmax];

void push(int v) {
    if (p[v] == -2) return;
    tree[v] = p[v];
    if (v * 2 + 1 >= 4 * nmax) {
        p[v] = -2;
        return;
    }
    p[v * 2] = p[v * 2 + 1] = p[v];
    p[v] = -2;
}

void upd(int v, int tl, int tr, int ql, int qr, int val) {
    push(v);
    if (tr <= ql || qr <= tl) return;
    if (ql <= tl && tr <= qr) {
        p[v] = val;
        push(v);
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2, tl, tm, ql, qr, val);
    upd(v * 2 + 1, tm, tr, ql, qr, val);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

int get(int v, int tl, int tr, int ql, int qr) {
    push(v);
    if (tr <= ql || qr <= tl) return -2;
    if (ql <= tl && tr <= qr) return tree[v];
    int tm = (tl + tr) / 2;
    return max(get(v * 2, tl, tm, ql, qr), get(v * 2 + 1, tm, tr, ql, qr));
}

void dfs2(int v, int &cur) {

    if (get(1, 1, nmax, v, v + 1) == -1) num[v] = cur++;

    if (g[v][0])
        dfs2(g[v][0], cur);

    if (get(1, 1, nmax, v, v + 1) == 0) num[v] = cur++;

    if (g[v][1])
        dfs2(g[v][1], cur);

    if (get(1, 1, nmax, v, v + 1) == 1) num[v] = cur++;
}

void dfs(int v, int &cur) {

    if (arr[v] == -1) num[v] = cur++;

    if (g[v][0])
        dfs(g[v][0], cur);

    if (arr[v] == 0) num[v] = cur++;

    if (g[v][1])
        dfs(g[v][1], cur);

    if (arr[v] == 1) num[v] = cur++;
}

void runtimeerror() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> g[i][0] >> g[i][1];

    vector<vector<int>> qu(q);
    int cuu = 0;
    for (int i = 0; i < q; i++) {
        vector<int> res(4);
        cin >> res[0];
        if (res[0] == 1)
            cin >> res[1] >> res[2] >> res[3], cuu++;
        else
            cin >> res[1];
        qu[i] = res;
    }

    if (n <= 5000 || cuu <= 10) {
        int cur = 1;
        dfs(1, cur);
        for (int i = 0; i < q; i++) {
            int t = qu[i][0];
            if (t == 1) {
                int l = qu[i][1], r = qu[i][2], x = qu[i][3];
                for (int j = l; j <= r; j++)
                    arr[j] = x;
                cur = 1;
                dfs(1, cur);
            } else {
                int x = qu[i][1];
                cout << num[x] << '\n';
            }
        }
    } else {
        int cur = 1;
        upd(1, 1, nmax, 1, nmax, -1);
        bool flag = false;
        for (int i = 0; i < q; i++) {
            int t = qu[i][0];
            if (t == 1) {
                int l = qu[i][1], r = qu[i][2], x = qu[i][3];
                upd(1, 1, nmax, l, r + 1, x);
            } else {
                if (!flag) {
                    flag = true;
                    dfs2(1, cur);
                }
                int x = qu[i][1];
                cout << num[x] << '\n';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    while (t--)
    runtimeerror();

//    cout << "OK";
    return 0;
}